'''
 * imports
'''	
import es
import psyco
psyco.full()
import os
import time
import gamethread
from sqlite3 import dbapi2 as sqlite

'''
 * define standards
'''	

AppList = []
AppOptions = {}
UsedPeoples = {}
NeedDBs = {}
UserApps = {}
UserRunTheApp = {}
debug = None

LogPath = es.getAddonPath("cssapps") + "/logs.log"
Prefix = "#lightgreen[#greenCss Apps#lightgreen]#green "


'''


 * start of lib
 
 
'''	

'''
 * app class
'''

class NewApp(object):
	'''
	 * InI the class
	 *
	 * @param AppName			name of the app (no space !!)
	 * @param NeedDB			need the app a DB (True, False)
	 * @param AllAllowed		can all users run the app (True, False)
	 * @noreturn
	'''
	def __init__(self, AppName, NeedDB = True, AllAllowed=True):
		self.App = AppName
		if not self.App in AppList:
			AppList.append(self.App)
			NeedDBs[AppName] = NeedDB
			if NeedDB:
				self.CreateTable()
			AddField("CSS_APPS", self.App)
			AppOptions[self.App] = {}
			UserApps[self.App] = {}
			UserApps[self.App]["all"] = AllAllowed
			UserApps[self.App]["auto"] = False
			UserApps[self.App]["always"] = False
			UserApps[self.App]["steamids"] = {}
			UserApps[self.App]["options"] = {}
			SQL.execute('INSERT INTO CSS_APPS_INFO (AppName) VALUES ("%s")' % (self.App))
			if CheckDebug("app"):
				PrintToLog("App %s loaded complete" % (self.App))
		else:
			PrintToLog("!!!!App %s already exists!!!!" % (self.App))
			es.server.queuecmd("es_unload cssapps/%s" % self.App)
	'''
	 * update the app description
	 *
	 * @param Description	the description
	 * @noreturn
	'''
	def Description(self, Description):
		SQL.execute('UPDATE CSS_APPS_INFO SET AppDescription = "%s" WHERE AppName="%s"' % (Description, self.App))
	'''
	 * update the app author
	 *
	 * @param Author	the author
	 * @noreturn
	'''
	def Author(self, Author):
		SQL.execute('UPDATE CSS_APPS_INFO SET AppAuthor = "%s" WHERE AppName="%s"' % (Author, self.App))
	'''
	 * update the app version
	 *
	 * @param Version	the version
	 * @noreturn
	'''
	def Version(self, Version):
		SQL.execute('UPDATE CSS_APPS_INFO SET AppVersion = "%s" WHERE AppName="%s"' % (Version, self.App))
		TheAppName = "cssapps-%s" % self.App
		es.set(TheAppName, Version)
		es.makepublic(TheAppName)
	'''
	 * change if the App runs on first time or not
	 *
	 * @param AutoOn			Run the App on first time (True, False)
	 * @noreturn
	'''
	def SetAutoOn(self, AutoOn):
		UserApps[self.App]["auto"] = AutoOn
	'''
	 * change if the App runs always or the user can change it
	 *
	 * @param AlwaysOn			Runs the App always (True, False)
	 * @noreturn
	'''
	def SetAlwaysOn(self, AlwaysOn):
		if AlwaysOn:
			UserApps[self.App]["auto"] = True
		UserApps[self.App]["always"] = AlwaysOn
	'''
	 * turn the app on for a user
	 *
	 * @param userid		userid
	 * @noreturn
	'''
	def TurnAppOn(self, userid):
		userid = str(userid)
		steamid = es.getplayersteamid(userid)
		IsOn = SQL.fetch('SELECT "%s" FROM CSS_APPS WHERE steamid = "%s"' % (self.App, steamid))
		if not IsOn:
			SQL.execute('INSERT INTO CSS_APPS (steamid) VALUES ("%s")' % (steamid))
			SQL.execute('INSERT INTO "%s" (steamid) VALUES ("%s")' % (self.App, steamid))
		SQL.execute('UPDATE CSS_APPS SET "%s" = "1" WHERE steamid="%s"' % (self.App, steamid))
		self.TurnTimerOn(userid)
		if not userid in UserRunTheApp.keys():
			UserRunTheApp[userid] = {}
			UserRunTheApp[userid][self.App] = {}
		UserRunTheApp[userid][self.App]["ON"] = "1"
	'''
	 * turn the app off for a user
	 *
	 * @param userid		userid
	 * @noreturn
	'''
	def TurnAppOff(self, userid):
		userid = str(userid)
		steamid = es.getplayersteamid(userid)
		IsOn = SQL.fetch('SELECT "%s" FROM CSS_APPS WHERE steamid = "%s"' % (self.App, steamid))
		if not IsOn:
			SQL.execute('INSERT INTO CSS_APPS (steamid) VALUES ("%s")' % (steamid))
			SQL.execute('INSERT INTO "%s" (steamid) VALUES ("%s")' % (self.App, steamid))
		SQL.execute('UPDATE CSS_APPS SET "%s" = "0" WHERE steamid="%s"' % (self.App, steamid))
		self.TurnTimerOn(userid)
		if not userid in UserRunTheApp.keys():
			UserRunTheApp[userid][self.App] = {}
		UserRunTheApp[userid][self.App]["ON"] = "0"
	'''
	 * create the app table
	 *
	 * @noreturn
	'''
	def CreateTable(self):
		SQL.execute('CREATE TABLE IF NOT EXISTS "%s" (steamid varchar(255) NOT NULL primary key)' % self.App)
	'''
	 * delete the app table
	 *
	 * @noreturn
	'''
	def DeleteTable(self):
		SQL.execute('DROP TABLE "%s"' % self.App)
	'''
	 * empty the Table
	 *
	 * @noreturn
	'''
	def EmptyTable(self):
		SQL.execute('DELETE FROM "%s"' % self.App)
		if not UserApps[self.App]["auto"]:
			SQL.execute('UPDATE "CSS_APPS" SET "%s"="0"' % self.App)
		else:
			SQL.execute('UPDATE "CSS_APPS" SET "%s"="1"' % self.App)
	'''
	 * check if a user can run the app
	 *
	 * @param userid		userid
	 * @return				True or False
	'''
	def IsUseridAllowed(self, userid):
		userid = str(userid)
		steamid = es.getplayersteamid(userid)
		if CheckBot(userid):
			return False
		if UserApps[self.App]["all"] or steamid in UserApps[self.App]["steamids"].keys():
			return True
		else:
			return False
	'''
	 * check if a steamid can run the app
	 *
	 * @param steamid		steamid
	 * @return				True or False
	'''
	def IsSteamidAllowed(self, steamid):
		if CheckBot(steamid):
			return False
		if UserApps[self.App]["all"] or steamid in UserApps[self.App]["steamids"].keys():
			return True
		else:
			return False
	'''
	 * allow the app for a userid
	 *
	 * @param userid		userid
	 * @noreturn
	'''
	def AllowUserid(self, userid):
		if not CheckBot(userid):
			steamid = es.getplayersteamid(userid)
			UserApps[self.App]["steamids"][steamid] = True
	'''
	 * disallow the app for a userid
	 *
	 * @param userid		userid
	 * @noreturn
	'''
	def DisallowUserid(self, userid):
		if not CheckBot(userid):
			steamid = es.getplayersteamid(userid)
			del (UserApps[self.App]["steamids"][steamid])
	'''
	 * allow the app for a steamid
	 *
	 * @param steamid		steamid
	 * @noreturn
	'''
	def AllowSteamid(self, steamid):
		if not CheckBot(steamid):
			UserApps[self.App]["steamids"][steamid] = True
	'''
	 * disallow the app for a steamid
	 *
	 * @param steamid		steamid
	 * @noreturn
	'''
	def DisallowSteamid(self, steamid):
		if not CheckBot(steamid):
			del (UserApps[self.App]["steamids"][steamid])
	"""
	 * check if the userid's limit is on
	 *
	 * @param userid		userid
	 * @return				True or False
	"""
	def CheckTimer(self, userid):
		if CheckBot(userid):
			return False
		userid = str(userid)
		if self.App in UsedPeoples.keys() and userid in UsedPeoples[self.App].keys():
			if UsedPeoples[self.App][userid] > 0:
				SayText("You still have to #lightgreenwait %i Seconds" % UsedPeoples[self.App][userid], userid)
				return False
			return True
		return True
	"""
	 * turn the userid's limit on
	 *
	 * @param userid		userid
	 * @noreturn
	"""
	def TurnTimerOn(self, userid):
		if not CheckBot(userid):
			userid = str(userid)
			if not self.App in UsedPeoples.keys():
				UsedPeoples[self.App] = {}
				UsedPeoples[self.App][userid] = 10
	'''
	 * add a new option
	 *
	 * @param Option		name of the option
	 * @param Standard		standard value
	 * @param Own			call an own block on select (True, False)
	 * @param Block			block to execute
	 * @param AllAllowed	every user can change the option (True, False)
	 * @return				option class
	'''
	def NewOption(self, Option, Standard=None, Own = False, Block = None, AllAllowed=True):	
		self.AddField(Option, Standard)
		return Options(Option, self.App, Own, Block, Standard, AllAllowed)
	'''
	 * add a new option field
	 *
	 * @param FieldName		name of the field
	 * @param standard		standard value
	 * @noreturn
	'''
	def AddField(self, FieldName, Standard=None):
		if not Standard:
			SQL.execute('ALTER TABLE "%s" ADD "%s" varchar(255) NOT NULL DEFAULT ""' % (self.App, FieldName))
		else:
			SQL.execute('ALTER TABLE "%s" ADD "%s" varchar(255) NOT NULL DEFAULT "%s"' % (self.App, FieldName, Standard))
	'''
	 * check if a userid run the app
	 *
	 * @param userid	userid
	 * @return			True or False
	'''
	def UserRunApp(self, userid):
		if CheckBot(userid):
			return False
		userid = str(userid)
		steamid = es.getplayersteamid(userid)
		if not userid in UserRunTheApp.keys() or UserRunTheApp[userid][self.App]["ON"] == "0":
			return False
		return True
			
'''
 option class
'''
class Options(object):
	'''
	 * ini the class
	 *
	 * @call 		called by app class
	 * @noreturn
	'''
	def __init__(self, OptionName, AppName, Own, Block, Standard, AllAllowed):
		self.option = OptionName
		self.appname = AppName
		AppOptions[self.appname][self.option] = {}
		AppOptions[self.appname][self.option]["self"] = Own
		AppOptions[self.appname][self.option]["standard"] = Standard
		AppOptions[self.appname][self.option]["selfblock"] = Block
		UserApps[self.appname]["options"][self.option] = {}
		UserApps[self.appname]["options"][self.option]["values"] = {}
		UserApps[self.appname]["options"][self.option]["all"] = AllAllowed
	'''
	 * allow the option for a userid
	 *
	 * @param userid		userid
	 * @noreturn
	'''
	def AllowUserid(self, userid):
		if not CheckBot(userid):
			steamid = es.getplayersteamid(userid)
			UserApps[self.appname]["options"][self.option][steamid] = True
	'''
	 * disallow the option for a userid
	 *
	 * @param userid		userid
	 * @noreturn
	'''
	def DisallowUserid(self, userid):
		if not CheckBot(userid):
			steamid = es.getplayersteamid(userid)
			del (UserApps[self.appname]["options"][self.option][steamid])
	'''
	 * allow the option for a steamid
	 *
	 * @param steamid		steamid
	 * @noreturn
	'''
	def AllowSteamid(self, steamid):
		if not CheckBot(steamid):
			UserApps[self.appname]["options"][self.option][steamid] = True
	'''
	 * disallow the option for a steamid
	 *
	 * @param steamid		steamid
	 * @noreturn
	'''
	def DisallowSteamid(self, steamid):
		if not CheckBot(steamid):
			del (UserApps[self.appname]["options"][self.option][steamid])
	'''
	 * add a value to the option
	 *
	 * @param Value 		value to add
	 * @param Description 	description of the value
	 * @param Own			call an own block on select (True, False)
	 * @param Block			block to execute
	 * @param AllAllowed 	can all change the option to this value (True, False)
	 * @noreturn
	'''
	def AddValue(self, Value, Description, Own = False, Block = None, AllAllowed = True):
		AppOptions[self.appname][self.option][Value] = {}
		AppOptions[self.appname][self.option][Value]["desc"] = Description
		AppOptions[self.appname][self.option][Value]["self"] = Own
		AppOptions[self.appname][self.option][Value]["selfblock"] = Block
		UserApps[self.appname]["options"][self.option]["values"][Value] = {}
		UserApps[self.appname]["options"][self.option]["values"][Value]["all"] = AllAllowed
	'''
	 * allow the value for a userid
	 *
	 * @param userid		userid
	 * @param Value			value to allow
	 * @noreturn
	'''
	def AllowUseridValue(self, userid, Value):
		if not CheckBot(userid):
			userid = str(userid)
			steamid = es.getplayersteamid(userid)
			UserApps[self.appname]["options"][self.option]["values"][Value][steamid] = True
	'''
	 * disallow the value for a userid
	 *
	 * @param userid		userid
	 * @param Value			value to disallow
	 * @noreturn
	'''
	def DisallowUseridValue(self, userid, Value):
		if not CheckBot(userid):
			userid = str(userid)
			steamid = es.getplayersteamid(userid)
			UserApps[self.appname]["options"][self.option]["values"][Value][steamid] = False
	'''
	 * allow the value for a steamid
	 *
	 * @param steamid		steamid
	 * @param Value			value to allow
	 * @noreturn
	'''
	def AllowSteamidValue(self, steamid, Value):
		if not CheckBot(steamid):
			UserApps[self.appname]["options"][self.option]["values"][Value][steamid] = True
	'''
	 * disallow the value for a steamid
	 *
	 * @param steamid		steamid
	 * @param Value			value to disallow
	 * @noreturn
	'''
	def DisallowSteamidValue(self, steamid, Value):
		if not CheckBot(steamid):
			UserApps[self.appname]["options"][self.option]["values"][Value][steamid] = False
	'''
	 * check if the user can change the option to the value
	 *
	 * @param userid		userid
	 * @param Value			value to check
	 * @return				True or False
	'''
	def IsUseridAllowedValue(self, userid, Value):
		if CheckBot(userid):
			return False
		userid = str(userid)
		steamid = es.getplayersteamid(userid)
		if UserApps[self.appname]["options"][self.option]["values"][Value]["all"] or UserApps[self.appname]["options"][self.option]["values"][Value][steamid]:
			return True
		else:
			return False
	'''
	 * get the value of the option
	 *
	 * @param userid		userid
	 * @return				value or False on error
	'''
	def GetOptionValue(self, userid):	
		if CheckBot(userid):
			return False
		userid = str(userid)
		steamid = es.getplayersteamid(userid)
		if userid in UserRunTheApp.keys():
			return UserRunTheApp[userid][self.appname][self.option]
		return False
	'''
	 * update the value of the option for a user
	 *
	 * @param userid		userid
	 * @param To			new value
	 * @noreturn
	'''
	def UpdateUserValue(self, userid, To):
		userid = str(userid)
		if not CheckBot(userid):
			To = str(To)
			steamid = es.getplayersteamid(userid)
			IsOn = SQL.fetch('SELECT * FROM "%s" WHERE steamid = "%s"' % (self.appname, steamid))
			if not IsOn:
				SQL.execute('INSERT INTO "%s" (steamid) VALUES ("%s")' % (self.appname, steamid))
			SQL.execute('UPDATE "%s" SET "%s" = "%s" WHERE steamid="%s"' % (self.appname, self.option, To, steamid))
			if userid in UserRunTheApp:
				UserRunTheApp[userid][self.appname][self.option] = To
	
'''
 * delete the app table
 *
 * @noreturn
'''
def DeleteTable(appname):
	SQL.execute('DROP TABLE "%s"' % appname)	
'''
 * empty the Table
 *
 * @noreturn
'''
def EmptyTable(appname):
	SQL.execute('DELETE FROM "%s"' % appname)
	if not UserApps[appname]["auto"]:
		SQL.execute('UPDATE "CSS_APPS" SET "%s"="0"' % appname)
	else:
		SQL.execute('UPDATE "CSS_APPS" SET "%s"="1"' % appname)
'''
 * say a text with prefix
 *
 * @param text			text to say(last color : #green)
 * @param userid		userid = es.tell, no userid = es.msg
 * @noreturn
'''	
def SayText(text, userid=None):
	if not userid:
		es.msg("#multi", "%s%s" % (Prefix, text))
	else:
		userid = str(userid)
		es.tell(userid, "#multi", "%s%s" % (Prefix, text))
'''
 * check if the user is a bot
 *
 * @param userid		userid
 * @return				True or False		
'''	
def CheckBot(userid):
	try:
		userid = int(userid)
		steamid = es.getplayersteamid(userid)
	except:
		steamid = userid
	if steamid == "BOT" or steamid == "STEAM_ID_PENDING":
		return True
	return False
'''
 * print a text to the logfile with time
 *
 * @param text		   	the text
 * @noreturn	
'''	
def PrintToLog(Text):
	if not os.path.isfile(LogPath):
		LogFile = open(LogPath, 'wb')
		LogFile.close()
	LogFile = open(LogPath, 'a')
	LogFile.write("%s: %s\n" % (GetTime(), Text))
	LogFile.close()
'''
 * print a text to the logfile without time
 *
 * @param text		   	the text
 * @noreturn	
'''	
def PrintToLogFree(Text):
	if not os.path.isfile(LogPath):
		LogFile = open(LogPath, 'wb')
		LogFile.close()
	LogFile = open(LogPath, 'a')
	LogFile.write("%s\n" % (Text))
	LogFile.close()
'''
 * check if the given debug is enabled
 *
 * @param DebugKind	   	"app" (app logging), "player" (player logging), "db" (db logging)
 * @return				True or False
'''	
def CheckDebug(DebugKind):
	if DebugKind == "app":
		if debug in (1, 3, 5, 7):
			return True
		return False
	if DebugKind == "player":
		if debug in (2, 3, 6, 7):
			return True
		return False
	if DebugKind == "db":
		if debug in (4, 5, 6, 7):
			return True
		return False
		
'''


 * end of lib
 
 
'''	
		
'''


 * only for the plugin:
 
 
'''			
class SQlite(object):
	def __init__(self):
		self.conn = sqlite.connect(AddonPath + "/apps.sq3", isolation_level=None)
		self.conn.text_factory = str
		self.cur = self.conn.cursor()
		if self.CheckConn():
			self.cur.execute("PRAGMA journal_mode=OFF")
			self.cur.execute("PRAGMA locking_mode=EXCLUSIVE")
			self.cur.execute("PRAGMA synchronous=OFF")
		if debug:
			PrintToLog("Connected to the Database")
	def CheckConn(self):
		if not self.conn or not self.cur:
			PrintToLog('!!!!!!There is no Connection to the Database!!!!!!!!')
			return False
		return True
	def execute(self, Query):
		if self.CheckConn():
			try:
				self.cur.execute(Query)
			except:
				if CheckDebug("db"):
					PrintToLog("Couldn't execute SQL CMD: %s" % Query)
		
	def fetch(self, Query):
		if self.CheckConn():
			self.cur.execute(Query)
			result = self.cur.fetchone()
			return result
			
def UserRunApp(userid, appname):
	if CheckBot(userid):
		return False
	userid = str(userid)
	steamid = es.getplayersteamid(userid)
	if not userid in UserRunTheApp.keys() or UserRunTheApp[userid][appname]["ON"] == "0":
		return False
	return True
	
def IsUseridAllowed(userid, appname):
	if CheckBot(userid):
		return False
	userid = str(userid)
	steamid = es.getplayersteamid(userid)
	if UserApps[appname]["all"] or UserApps[appname]["steamids"][steamid]:
		return True
	else:
		return False
	
def IsUseridAllowedOption(userid, appname, optionname):
	if CheckBot(userid):
			return False
	userid = str(userid)
	steamid = es.getplayersteamid(userid)
	if UserApps[appname]["options"][optionname]["all"] or UserApps[appname]["options"][optionname][steamid]:
		return True
	else:
		return False
		
def IsUseridAllowedValue(userid, appname, optionname, value):
	if CheckBot(userid):
		return False
	userid = str(userid)
	steamid = es.getplayersteamid(userid)
	if UserApps[appname]["options"][optionname]["values"][value]["all"] or UserApps[appname]["options"][optionname]["values"][value][steamid]:
		return True
	else:
		return False
		
def CheckTimer(userid, appname):
	if CheckBot(userid):
		return False
	userid = str(userid)
	if appname in UsedPeoples.keys() and userid in UsedPeoples[appname].keys():
		if UsedPeoples[appname][userid] > 0:
			SayText("You still have to #lightgreenwait %i Seconds" % UsedPeoples[appname][userid], userid)
			return False
		return True
	return True
	
def TurnTimerOn(userid, appname):
	if CheckBot(userid):
		return False
	userid = str(userid)
	if not appname in UsedPeoples.keys():
		UsedPeoples[appname] = {}
	UsedPeoples[appname][userid] = 10
	
def UpdateUserOption(userid, AppName, SetText, SetValue):
	if not CheckBot(userid):
		userid = str(userid)
		steamid = es.getplayersteamid(userid)
		IsOn = SQL.fetch('SELECT * FROM "%s" WHERE steamid = "%s"' % (AppName, steamid))
		if not IsOn:
			SQL.execute('INSERT INTO "%s" (steamid) VALUES ("%s")' % (AppName, steamid))
		SQL.execute('UPDATE "%s" SET "%s" = "%s" WHERE steamid="%s"' % (AppName, SetText, SetValue, steamid))
		if userid in UserRunTheApp:
			UserRunTheApp[userid][AppName][SetText] = SetValue
			
def TurnAppOn(userid, appname):
	userid = str(userid)
	steamid = es.getplayersteamid(userid)
	IsOn = SQL.fetch('SELECT "%s" FROM CSS_APPS WHERE steamid = "%s"' % (appname, steamid))
	if not IsOn:
		SQL.execute('INSERT INTO CSS_APPS (steamid) VALUES ("%s")' % (steamid))
		SQL.execute('INSERT INTO "%s" (steamid) VALUES ("%s")' % (appname, steamid))
	SQL.execute('UPDATE CSS_APPS SET "%s" = "1" WHERE steamid="%s"' % (appname, steamid))
	TurnTimerOn(userid, appname)
	if not userid in UserRunTheApp.keys():
		UserRunTheApp[userid] = {}
		UserRunTheApp[userid][appname] = {}
	UserRunTheApp[userid][appname]["ON"] = "1"
	
def TurnAppOff(userid, appname):
	userid = str(userid)
	steamid = es.getplayersteamid(userid)
	IsOn = SQL.fetch('SELECT "%s" FROM CSS_APPS WHERE steamid = "%s"' % (appname, steamid))
	if not IsOn:
		SQL.execute('INSERT INTO CSS_APPS (steamid) VALUES ("%s")' % (steamid))
		SQL.execute('INSERT INTO "%s" (steamid) VALUES ("%s")' % (appname, steamid))
	SQL.execute('UPDATE CSS_APPS SET "%s" = "0" WHERE steamid="%s"' % (appname, steamid))
	TurnTimerOn(userid, appname)
	if not userid in UserRunTheApp.keys():
		UserRunTheApp[userid][appname] = {}
	UserRunTheApp[userid][appname]["ON"] = "0"
			
def AddField(Table, FieldName):
	SQL.execute('ALTER TABLE "%s" ADD "%s" varchar(255) NOT NULL DEFAULT ""' % (Table, FieldName))
		
def InIUser(userid, appnames=None):
	if not CheckBot(userid):
		userid = str(userid)
		steamid = es.getplayersteamid(userid)
		if CheckDebug("player"):
			PrintToLog("Steamid: %s InI" % steamid)
		if not appnames:
			UserRunTheApp[userid] = {}
			for appname in AppList:
				UserRunTheApp[userid][appname] = {}
				if not steamid in UserApps[appname]["steamids"]:
					UserApps[appname]["steamids"][steamid] = False
				IsOn = SQL.fetch('SELECT "%s" FROM CSS_APPS WHERE steamid = "%s"' % (appname, steamid))
				if UserApps[appname]["always"]:
					UserRunTheApp[userid][appname]["ON"] = "1"
				else:
					if IsOn:
						if IsOn[0] == "1":
							UserRunTheApp[userid][appname]["ON"] = "1"
						else:
							UserRunTheApp[userid][appname]["ON"] = "0"
					else:
						if not UserApps[appname]["auto"]:
							UserRunTheApp[userid][appname]["ON"] = "0"
						else:
							UserRunTheApp[userid][appname]["ON"] = "1"
				for x in AppOptions[appname]:
					if not steamid in UserApps[appname]["options"][x].keys():
						UserApps[appname]["options"][x][steamid] = False
					for y in UserApps[appname]["options"][x]["values"]:
						if not steamid in UserApps[appname]["options"][x]["values"][y].keys():
							UserApps[appname]["options"][x]["values"][y][steamid] = False
					Result = SQL.fetch('SELECT "%s" FROM "%s" WHERE steamid = "%s"' % (x, appname, steamid))
					if Result:
						UserRunTheApp[userid][appname][x] = Result[0]
					else:
						UserRunTheApp[userid][appname][x] = AppOptions[appname][x]["standard"]
		else:
			UserRunTheApp[userid][appnames] = {}
			if not steamid in UserApps[appnames]["steamids"]:
				UserApps[appnames]["steamids"][steamid] = False
			IsOn = SQL.fetch('SELECT "%s" FROM CSS_APPS WHERE steamid = "%s"' % (appnames, steamid))
			if UserApps[appname]["always"]:
				UserRunTheApp[userid][appnames]["ON"] = "1"
			else:
				if IsOn:
					if IsOn[0] == "1":
						UserRunTheApp[userid][appnames]["ON"] = "1"
					else:
						UserRunTheApp[userid][appnames]["ON"] = "0"
				else:
					if not UserApps[appnames]["auto"]:
						UserRunTheApp[userid][appnames]["ON"] = "0"
					else:
						UserRunTheApp[userid][appnames]["ON"] = "1"
			for x in AppOptions[appnames]:
				if not steamid in UserApps[appnames]["options"][x].keys():
					UserApps[appnames]["options"][x][steamid] = False
				for y in UserApps[appnames]["options"][x]["values"]:
					if not steamid in UserApps[appnames]["options"][x]["values"][y].keys():
						UserApps[appnames]["options"][x]["values"][y][steamid] = False
				Result = SQL.fetch('SELECT "%s" FROM "%s" WHERE steamid = "%s"' % (x, appnames, steamid))
				if Result:
					UserRunTheApp[userid][appnames][x] = Result[0]
				else:
					UserRunTheApp[userid][appnames][x] = AppOptions[appnames][x]["standard"]
					
def GetInfos(appname):
	Infos = SQL.fetch('SELECT AppVersion, AppDescription, AppAuthor FROM CSS_APPS_INFO WHERE AppName = "%s"' % (appname))
	if Infos:
		return Infos
	else:
		return False
		
def OpenBlock(userid, BlockName):
	userid = str(userid)
	try:
		BlockName(userid)
	except:
		if CheckDebug("app"):
			PrintToLog("Couldn't execute Block: %s (Not found or faulty)" % str(BlockName))
		
def GetTime():
	return time.strftime('%d/%m/%y %H:%M:%S')
		
def UseridTimer():
	for x in UsedPeoples.keys():
		for y in UsedPeoples[x].keys():
			UsedPeoples[x][y] = UsedPeoples[x][y] - 1
			if UsedPeoples[x][y] <= 0:
				del UsedPeoples[x][y]
	gamethread.delayedname(1, "UseridTimer", UseridTimer)
		
def InIDB(AddonPaths):
	global SQL
	global AddonPath
	if debug:
		PrintToLog("Start InI DB")
	AddonPath = AddonPaths
	SQL = SQlite()
	SQL.execute('CREATE TABLE IF NOT EXISTS CSS_APPS (steamid varchar(255), PRIMARY KEY(steamid))')
	SQL.execute('CREATE TABLE IF NOT EXISTS CSS_APPS_INFO (AppName varchar(255), AppVersion varchar(255) NOT NULL DEFAULT "", AppDescription varchar(255) NOT NULL DEFAULT "", AppAuthor varchar(255) NOT NULL DEFAULT "", PRIMARY KEY(AppName))')
	gamethread.cancelDelayed("UseridTimer")
	UseridTimer()